<template>
  <div class="page-body">
    <div class="page-search row items-center">
      <div class="col row wrap q-mr-lg q-col-gutter-md">
        <div class="col-3">
          <q-input @change="resetSearch" clearable standout="bg-primary text-white" class="col-6 q-pr-lg q-pr-lg"
            v-model="msg.Title" label="标题" maxlength="20" @clear="resetSearch" />
        </div>
        <div class="col-3">
          <q-select @input="resetSearch" standout="bg-primary text-white" class="col-6 q-pr-lg q-pr-lg"
            v-model="msg.Status" :options="ShowOpts" emit-value map-options label="状态" />
        </div>
        <div class="col-3">
          <q-select @input="resetSearch" option-value="Id" option-label="TypeName" standout="bg-primary text-white" class="col-6 q-pr-lg q-pr-lg"
            v-model="msg.TypeId" :options="TypeList" emit-value map-options label="类型" />
        </div>
      </div>
    </div>
    <div class="page-content">
      <q-table :pagination="msg" :loading="loading" no-data-label="暂无相关数据" flat class="sticky-column-table"
        separator="none" :data="data" :columns="columns" row-key="name">
        <template v-slot:top="props">
          <div class="col-2 q-table__title">新闻信息</div>
          <q-space />
          <div class="page-option">
            <q-btn color="accent" class="q-mr-md" size="sm" icon="add" label="新增新闻" @click="EditMenu(null)" />
          </div>
        </template>
        <template v-slot:body-cell-Img="props">
          <q-td :props="props">
            <img :src="props.row.Img" style="width:50px;" />
          </q-td>
        </template>
        <!-- <template v-slot:body-cell-Content="props">
          <q-td :props="props">
            <div v-html="props.row.Content"></div>
          </q-td>
        </template> -->
        <template v-slot:body-cell-Status="props">
           <q-td :props="props">
            <q-toggle size="md" color="primary" :false-value="1" :true-value="0" v-model="props.row.Status"
              title="注意：关闭后，分类将无法正常使用." @input="DeleteMenu(props.row)" />
           </q-td>
        </template>
        <template v-slot:bottom>
          <q-pagination class="full-width justify-end" v-model="msg.pageIndex" color="primary" :max="pageCount"
            :input="true" @input="changePage" />
        </template>
        <template v-slot:body-cell-optioned="props">
          <q-td :props="props">
            <q-btn flat size="xs" icon="edit" color="accent" style="font-weight:400" label="编辑"
              @click="EditMenu(props.row)" />
          </q-td>
        </template>
      </q-table>
      <news-form v-if="isShowNewsForm" :save-obj="menuObjOption" @close="closeMenuSaveForm" @success="refreshPage">
      </news-form>
    </div>
  </div>
</template>
<script>
  import {
    GetWebNewsPage,
    RemoveWebMenuStatus,
    GetWebNewsTypeList,
    RemoveWebNewsStatus
  } from '../../api/system/webkit'
  import newsForm from '../../components/system/news-form'
  export default {
    meta: {
      title: "菜单管理"
    },
    components: {
      newsForm
    },
    data() {
      return {
        columns: [{
            name: 'Title',
            label: '标题',
            field: 'Title',
            align: 'left'
          },
          {
            name: 'Img',
            label: '图片',
            field: 'Img',
            align: 'left'
          },
          {
            name: 'Status',
            label: '状态',
            field: 'Status',
            align: 'left'
          },
          {
            name: 'optioned',
            label: '操作',
            field: 'MenuId'
          }
        ],
        data: [],
        loading: true,
        ShowOpts: [{
            label: '全部',
            value: -1
          },
          {
            label: '正常',
            value: 0
          },
          {
            label: '删除',
            value: 1
          }
        ],
        msg: {
          pageIndex: 1,
          pageSize: 12,
          rowsPerPage: 12,
          Title:'',
          TypeId:0,
          Status: -1
        },
        pageCount: 0,
        TypeList:[],
        isShowNewsForm: false,
        menuObjOption: null,
      }
    },
    mounted() {
      this.getWebNews();
      this.getList()
    },
    methods: {
      //修改菜单状态
      DeleteMenu(obj) {
        var that = this;
        var delMsg = {
          Id: obj.Id,
          Status: obj.Status
        };
        var tipMsg = "";
        if (delMsg.Status == 0) {
          tipMsg = "是否启用【" + obj.Title + "】?";
        } else {
          tipMsg = "是否禁用【" + obj.Title + "】?";
        }
        this.$q.dialog({
          title: '提示信息',
          message: tipMsg,
          cancel: true,
          persistent: true,
          ok: "确定",
          cancel: "取消",
        }).onOk(() => {
          RemoveWebNewsStatus(delMsg).then(res => {
            if (res.Code == 1) {
              that.$q.notify({
                icon: 'iconfont icon-chenggong',
                color: 'accent',
                timeout: 2000,
                message: '操作成功',
                position: 'top'
              })
              that.getList();
            }
          })
        }).onCancel(() => {
          obj.Status = obj.Status == 1 ? 0 : 1;
        });
      },
      //重新查询
      resetSearch() {
        this.msg.pageIndex = 1;
        this.getList();
      },
      //翻页
      changePage(val) {
        this.msg.pageIndex = val;
        this.getList()
      },
      //获取菜单分页列表
      getList() {
        this.loading = true;
        GetWebNewsPage(this.msg).then(res => {
          this.loading = false
          this.data = res.Data.PageData;
          this.pageCount = res.Data.PageCount;
        }).catch(() => {
          this.loading = false
        })
      },
      //获取下拉数据
      getWebNews(){
        GetWebNewsTypeList({}).then(res => {
          this.TypeList = res.Data;
          let obj = {
            Id:0,
            TypeName:'不限'
          }
          this.TypeList.unshift(obj);
        }).catch(() => {
        })
      },

      //刷新页面
      refreshPage() {
        if (!this.menuObjOption) {
          this.msg.pageIndex = 1;
          this.msg.Title = "";
          this.msg.TypeId = 0;
          this.msg.Status = "-1";
        }
        this.getList()
      },
      //新增修改菜单
      EditMenu(obj) {
        if (obj) {
          this.menuObjOption = obj
        } else {
          this.menuObjOption = null
        }
        this.isShowNewsForm = true
      },
      //关闭弹窗
      closeMenuSaveForm() {
        this.isShowNewsForm = false
      },
    }
  }

</script>
<style lang="sass">
  @import url('~assets/css/table.sass')

</style>
